pragma solidity ^0.5.0;

import '../tokenauth/IAuthority.sol';


// Authority tester
contract AuthorityTester {
    mapping(address=>IAuthority[]) private authorities;

    event EstablishedAuthority(address _address, address _authority);

    constructor() public {
    }

    function testAuthority(address _caller,
                           address _sender,
                           address _holder,
                           address _recipient,
                           uint256 _id,
                           uint256 _amount,
                           uint256 _value,
                           bytes memory _callerData,
                           bytes memory _senderData,
                           bytes memory _holderData)
    public {
      IAuthority[] memory senderAuthorities = authorities[_holder];
      if (senderAuthorities.length == 0) {
          revert("no authorities");
      }

      for (uint256 i = 0; i < senderAuthorities.length; i++) {
        if (senderAuthorities[i].authorise(_caller, _sender, _holder, _recipient, _id, _amount, _value, _callerData, _senderData, _holderData)) {
          return;
        }
      }

      revert("no authority");
    }

    function getAuthorities(address _holder) public view returns (IAuthority[] memory) {
      return authorities[_holder];
    }

    function addAuthority(IAuthority _authority) public { 
      authorities[msg.sender].push(_authority);
      emit EstablishedAuthority(msg.sender, address(_authority));
    }
}
