pragma solidity ^0.5.0;

import "./IAuthority.sol";

// Copyright © 2019 Weald Technology Trading Limited
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

/**
 * @title HolderAuthority
 *        HolderAuthority is an authority based on the address of the sender
 *        being equal to the address of the holder.
 *
 *        State of this contract: under development.
 *
 * @author Jim McDonald
 */
contract HolderAuthority is IAuthority {
    function authorise(address /*_caller*/,
                       address _sender,
                       address _holder,
                       address /*_recipient*/,
                       uint256 /*_id*/,
                       uint256 /*_amount*/,
                       uint256 /*_value*/,
                       bytes calldata /*_callerData*/,
                       bytes calldata /*_senderData*/,
                       bytes calldata /*_holderData*/)
    external returns (bool) {
      return (_sender == _holder);
    }
}
